#include "TestInjective_main.h"
#include <TestInjective.h>

CState * CORBTestInjective_main::Exec(CState *s)
{
CRuleBlock * TestInjective= new CORBTestInjective;
CStmt * _rStmt_ =
new CRuleInvokeStmt(TestInjective, NULL);
CState * new_s = _rStmt_->Exec(s);
delete _rStmt_;
delete TestInjective;
return new_s;
}

CState * CORBTestInjective_main::ExecDebug(CState *s, DDebugController *db)
{
CRuleBlock * TestInjective= new CORBTestInjective;
CStmt * _rStmt_ =
new CRuleInvokeStmt(TestInjective, NULL);
CState * new_s = _rStmt_->ExecDebug(s, db);
delete _rStmt_;
delete TestInjective;
return new_s;
}

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include "PAParser.H"
#include "KONonType.H"

#include "QLParser.H"
int main(int argc, char *argv[])
{
	NonType * qTree = NULL;
	if(argc < 1) qTree = PAParser().parse();
	else if(argc == 2) {
		if(strcmp("-q", argv[1]) == 0)
			qTree = PAParser().parse();
		else
			if(strcmp("-ddebug", argv[1]) == 0)
				_debug_ = 1, qTree = PAParser().parse();
			else if(strcmp("-cldbg", argv[1]) == 0)
				_cldbg_ = 1, qTree = PAParser().parse();
			else if(strcmp("-clcokodb", argv[1]) == 0)
				_clcokodb_ = 1, qTree = PAParser().parse();
			else qTree = PAParser(argv[1]).parse();
	}
	else if (argc == 3) {
		if(strcmp("-q", argv[1]) == 0)
			qTree = QLParser(argv[2]).parse();
		else if(strcmp("-q", argv[2]) == 0) {
			qTree = QLParser(argv[1]).parse();
		}
		else
		if(strcmp("-ddebug", argv[1]) == 0) {
			_debug_ = 1, qTree = PAParser(argv[2]).parse();
		}
		else if(strcmp("-ddebug", argv[2]) == 0) {
			_debug_ = 1, qTree = PAParser(argv[1]).parse();
		}
		else if(strcmp("-cldbg", argv[1]) == 0) {
			_cldbg_ = 1, qTree = PAParser(argv[2]).parse();
		}
		else if(strcmp("-cldbg", argv[2]) == 0) {
			_cldbg_ = 1, qTree = PAParser(argv[1]).parse();
		}
		else if(strcmp("-clcokodb", argv[1]) == 0) {
			_clcokodb_ = 1, qTree = PAParser(argv[2]).parse();
		}
		else if(strcmp("-clcokodb", argv[2]) == 0) {
			_clcokodb_ = 1, qTree = PAParser(argv[1]).parse();
		}
	}
	if(!qTree) exit(1);
	CRuleBlock * MainRB = new CORBTestInjective_main;
	CState *s = MainRB->Exec(new CState(qTree,new CIEnvStack(),0));
	delete MainRB; delete s;
}
