TRANSFORMATION SimplifyJoin
 USES
  SJ1:  join (p OPLUS (f X g), #2) ! [A, B] --> join (p OPLUS (id X g), #2) ! [iterate (K (true), f) ! A, B],
  SJ2:  iterate (p, f) ! (iterate (q, id) ! A) --> iterate (p & q, f) ! A,
  SJ3:  set ! (join (=, #2) ! [A, B]) --> set ! (int (=) ! [A, B]),
  SJ4:  int (=) ! [iterate (p, f) ! A, iterate (K (true), f) ! A] --> iterate (p, f) ! A,
  SJ5a: f o ID --> f,
  SJ5b: ID o f --> f,
  SJ6a: K (true) & p --> p,
  SJ6b: p & K (true) --> p,
  SJ7:  K (true) OPLUS f --> K (true),
  SJ8:  p OPLUS ID --> p,
  SJ9:  ID X ID --> ID,
  SJ10: iterate (p, f) ! (join (q, g) ! [A, B]) --> join (q & (p OPLUS g), f o g) ! [A, B],
  Pushdown
 BEGIN
  GIVEN _F ! A DO SJ1 (A);  
  GIVEN _F ! (_F ! [A, _O]) DO SJ2 (A);
  BU {SJ5a || SJ5b || SJ6a || SJ6b || SJ7 || SJ8 || SJ9};
  SJ3;
  GIVEN _F ! A DO SJ4 (A);
  BU {SJ5a || SJ5b || SJ6a || SJ6b || SJ7 || SJ8 || SJ9};
  TD {SJ10 -> Pushdown}
 END

  
  
