//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Marina Zlatkina
//  FILE: CustomProperty.H
//  PROJ: COKO
//  DATE: 8/2001                                                            
//
// SYNOPSIS
//  Superclass of all compiled properties.
//  
//////////////////////////////////////////////////////////////////////////////
#ifndef _CUSTOMPROPERTY_H
#define _CUSTOMPROPERTY_H

#include "Property.H"
class NonTypeArgs;

class CustomProperty : public Property{
protected:
  Property * root;
  // the property which must be true

public:
  CustomProperty(Property *);
  // constructor

  virtual NonTypeArgs * isTrue( CState *, NonTypeArgs *);
  // returns the result of evaluting the isTrue method of root
};

#endif
