//////////////////////////////////////////////////////////////////////////////
//                                                                          
//  NAME: Daniel Abadi 
//  FILE: DEVisNodeInfo.C
//  PROJ: COKO DEBUGGER
//  DATE: WINTER 2002                                               
//
// SYNOPSIS
// 
//  Class methods for visual node display. This will contain the location
//  of the top left corner and the bottom right corner of a node used in the
//  visual display of a COKO tree. This is used in DEPaintWindow.H
//  
//////////////////////////////////////////////////////////////////////////////

#ifndef _DVISNODEINFO_C_
#define _DVISNODEINFO_C_

#include "DEVisNodeInfo.H"

//////////////////////////////////////////////////////////////////////////////
//                                                                          
// Function Name: DVisNodeInfo
// Parameters:	(int,int,int,int)
//
// Constructor.
//         								    
//////////////////////////////////////////////////////////////////////////////

DVisNodeInfo::DVisNodeInfo(int left, int top, int right, int bottom)
{
  _top = top;
  _left = left;
  _bottom = bottom;
  _right = right;
}

#endif

