/*
 * Copyright 1995, Brown University, Providence, RI
 *
 * Permission to use and modify this software and its documentation for
 * any purpose other than its incorporation into a commercial product is
 * hereby granted without fee.  Permission to copy and distribute this
 * software and its documentation only for non-commercial use is also
 * granted without fee, provided, however, that the above copyright notice
 * appear in all copies, that both that copyright notice and this permission
 * notice appear in supporting documentation, that the name of Brown
 * University not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission,
 * and that the person doing the distribution notify Brown University of
 * such distributions outside of his or her organization. Brown University
 * makes no representations about the suitability of this software for
 * any purpose.  It is provided "as is" without express or implied warranty.
 * Brown University requests notification of any modifications to this
 * software or its documentation.
 *
 * Send the following redistribution information:
 *
 *	Name:
 *	Organization:
 *	Address (postal and/or electronic):
 *
 * To:
 *	Software Librarian
 *	Computer Science Department, Box 1910
 *	Brown University
 *	Providence, RI 02912
 *
 *		or
 *
 *	brusd@cs.brown.edu
 *
 * We will acknowledge all electronic notifications.
 */
/*
//////////////////////////////////////////////////////////////////////////////
//
// NAME: Joon S. Lee (jl@cs.brown.edu)					 	 
// FILE: PPMain.C
// PROJ: COKO Compiler
// DATE: 8/97
//
//////////////////////////////////////////////////////////////////////////////
*/
/* -*-Mode:c++-*- */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fstream.h>
//#include <libc.h>
 
#define TRUE 1
#define FALSE 0
 
extern int CLlex();
extern char **targv;
extern char **arglim;
extern char *commandline;
 
void fatal(char *s, char *s2 = "")
{
  cerr << s << " : " << s2 << '\n';
  exit(1);
}
 
main(int argc, char *argv[])
{
  targv = argv + 1;
  arglim = argv + argc;
  CLlex();
  return 0;
}

