#ifndef _DVERTSPLIT_H_
#define _DVERTSPLIT_H_
#include "VC.H"
#include <qmultilineedit.h>
#include <qsplitter.h>
#include <qvaluelist.h>
#include <qfile.h>

class MyMainWindow;
class DHorizSplit;

class DVertSplit: public QSplitter
{
  
public:
  DVertSplit(MyMainWindow *parent=0, const char *name=0, QMultiLineEdit* top=0, QMultiLineEdit* bottom=0);
  void setNormalPalette();
  void setCurrPalette();
  void dealWithSelection(QString*);
  void setRelativeSizes(int,int);
  
private:
  QPalette palette;
  QMultiLineEdit* topEdit;
  QMultiLineEdit* bottomEdit;
  MyMainWindow * parentWid;
};

#endif
