/* output from Ox version G1.04 */
%{
%}
/////////////////////////////////////////////////////////////////////////////
//
// Name: Xioayu Wang
// File: XMLQL.y
// Proj: XMLQL -> KOLA translator (ox input file)
// Date: 10/00
//
/////////////////////////////////////////////////////////////////////////////

%token  LT  GT  LTSLASH  SLASHGT  WHERE  CONSTRUCT  ELEMENTAS  CONTENTAS  INN
%token  STRING  VAR  ID  COMMA  EQ  NEQ  LBRACE  RBRACE  STAR  DOT  BAR  PLUS

     
  
 
                      
  

%start yyyAugNonterm

%{
#include "KGlobals.H"
#include "KOFShiftL.H"
#include "KOFShiftR.H"
#include "KOBAnd.H"
#include "KOBEqu.H"
#include "KOBGE.H"
#include "KOBGT.H"
#include "KOBInvoke.H"
#include "KOBLE.H"
#include "KOBLT.H"
#include "KOBName.H"
#include "KOBNot.H"
#include "KOBOr.H"
#include "KOBPrimitive.H"
#include "KOBVar.H"
#include "KOBool.H"
#include "KOF1.H"
#include "KOF2.H"
#include "KOFAbs.H"
#include "KOFAdd.H"
#include "KOFAvg.H"
#include "KOFCElt.H"
#include "KOFChoose.H"
#include "KOFCompose.H"
#include "KOFCon.H"
#include "KOFConst.H"
#include "KOFCount.H"
#include "KOFDif.H"
#include "KOFDiv.H"
#include "KOFFlatten.H"
#include "KOFFold.H"
#include "KOFID.H"
#include "KOFTID.H"
#include "KOFIns.H"
#include "KOFInt.H"
#include "KOFInverse.H"
#include "KOFIter.H"
#include "KOFIterate.H"
#include "KOFJoin.H"
#include "KOFLSJoin.H"
#include "KOFMax.H"
#include "KOFMin.H"
#include "KOFMinus.H"
#include "KOFMod.H"
#include "KOFMult.H"
#include "KOFNJoin.H"
#include "KOFPCon.H"
#include "KOFPFold.H"
#include "KOFPlus.H"
#include "KOFRSJoin.H"
#include "KOFSet.H"
#include "KOFSingleton.H"
#include "KOFSort.H"
#include "KOFSum.H"
#include "KOFTimes.H"
#include "KOFUni.H"
#include "KOFUnnest.H"
#include "KOFUser.H"
#include "KOFVar.H"
#include "KOFunction.H"
#include "KONameUnion.H"
#include "KONonType.H"
#include "KOOAny.H"
#include "KOODif.H"
#include "KOODiv.H"
#include "KOOFloat.H"
#include "KOOId.H"
#include "KOOIf.H"
#include "KOOInt.H"
#include "KOOInter.H"
#include "KOOInvoke.H"
#include "KOOLink.H"
#include "KOOMinus.H"
#include "KOOMult.H"
#include "KOOName.H"
#include "KOOPair.H"
#include "KOOPlus.H"
#include "KOOSet.H"
#include "KOOStr.H"
#include "KOOTimes.H"
#include "KOOUni.H"
#include "KOOVar.H"
#include "KOObjList.H"
#include "KOObject.H"
#include "KOPCEX.H"
#include "KOPCElt.H"
#include "KOPCFA.H"
#include "KOPCombine.H"
#include "KOPConjunct.H"
#include "KOPConst.H"
#include "KOPDisjunct.H"
#include "KOPEqual.H"
#include "KOPExists.H"
#include "KOPForall.H"
#include "KOPGreater.H"
#include "KOPGreaterEqual.H"
#include "KOPInv.H"
#include "KOPIsnotnull.H"
#include "KOPIsnull.H"
#include "KOPLess.H"
#include "KOPLessEqual.H"
#include "KOPLex.H"
#include "KOPNegate.H"
#include "KOPNotEqual.H"
#include "KOPTimes.H"
#include "KOPUser.H"
#include "KOPVar.H"
#include "KOPredicate.H"
#include "KOTWrap.H"

#include "KOTag.H"
#include "KOTagExp.H"
#include "KOTagExpList.H"
#include "KOTTilde.H"

#include "TYTAny.H"
#include "TYTBag.H"
#include "TYTBool.H"
#include "TYTChar.H"
#include "TYTDC.H"
#include "TYTError.H"
#include "TYTFlt.H"
#include "TYTFunc.H"
#include "TYTInt.H"
#include "TYTObj.H"
#include "TYTPair.H"
#include "TYTPred.H"
#include "TYTSet.H"
#include "TYTStr.H"
#include "TYTTup.H"
#include "TYTUnk.H"
#include "TYTUser.H"
#include "TYTVar.H"
#include "TYType.H"

#include "ENEnvironment.H"
#include "ENEnvEntry.H"


#include <stdio.h>
#include <string.h>
#include <iostream.h>

#include "QLAuxCode.H"

  extern int lineno3;
  extern int QLlex();
  extern char *QLtext;
  
  int QLerror (char *);
  extern NonType *result;

%}


%{


struct yyyT1 {char *str;}; 
typedef struct yyyT1 *yyyP1; 


struct yyyT2 {Tag *tag; TagExp *path;  TagExp *trans; TagExp *env;}; 
typedef struct yyyT2 *yyyP2; 


struct yyyT3 {TagExp *path; TagExpList *trans; TagExp *env;}; 
typedef struct yyyT3 *yyyP3; 


struct yyyT4 {Function *trans ;}; 
typedef struct yyyT4 *yyyP4; 


struct yyyT5 {Predicate *trans;}; 
typedef struct yyyT5 *yyyP5; 
                                                      /*custom*/  
typedef unsigned char yyyWAT; 
typedef unsigned char yyyRCT; 
typedef unsigned short yyyPNT; 
typedef unsigned char yyyWST; 

#include <limits.h>
#define yyyR UCHAR_MAX  

 /* funny type; as wide as the widest of yyyWAT,yyyWST,yyyRCT  */ 
typedef unsigned short yyyFT;

                                                      /*stock*/  




struct yyyGenNode {void *parent;  
                   struct yyyGenNode **cL; /* child list */ 
                   yyyRCT *refCountList; 
                   yyyPNT prodNum;                      
                   yyyWST whichSym; /* which child of parent? */ 
                  }; 

typedef struct yyyGenNode yyyGNT; 



struct yyyTB {int isEmpty; 
              int typeNum; 
              int nAttrbs; 
              char *snBufPtr; 
              yyyWAT *startP,*stopP; 
             };  




extern struct yyyTB yyyTermBuffer; 
extern yyyWAT yyyLRCIL[]; 
extern void yyyGenLeaf(int nAttrbs,int typeNum,
                       yyyWAT *startP,yyyWAT *stopP
                      ); 


%}

%{
#include <stdio.h>
#include <stdlib.h>

int yyyYok = 1;
int yyyInitDone = 0;
char *yyySTsn;
yyyGNT *yyySTN;
int yyyGNSz = sizeof(yyyGNT);
int yyyProdNum,yyyRHSlength,yyyNattrbs,yyyTypeNum; 

extern yyyFT yyyRCIL[];

void yyyExecuteRRsection();
void yyyYoxInit();
void yyyYoxReset();
void yyyDecorate();
void yyyGenIntNode();
void yyyAdjustINRC(register yyyFT *,register yyyFT *);
void yyyUnsolvedInstSearchTrav(yyyGNT *pNode);
void yyyUnsolvedInstSearchTravAux(yyyGNT *pNode);
void yyyPrune(long prodNum);
void yyyerror();
void yyyShift();



#define yyyRSU(NUM1,NUM2,NUM3,NUM4) \
   yyyProdNum=NUM1;yyyRHSlength=NUM2;yyyNattrbs=NUM3;yyyTypeNum=NUM4;\
   if ((yychar <= 0) && (!yyyTermBuffer.isEmpty)) yyyShift(); 
%}


%%

yyyAugNonterm 
	:	{if (!yyyInitDone) 
		    {yyyYoxInit(); 
		     yyyInitDone = 1;
		    }
		 yyyYoxReset();
		}
		S
		{
		 yyyDecorate(); yyyExecuteRRsection();
		}
	;
S       :	Q
        {if(yyyYok){
yyyRSU(1,1,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+0,yyyRCIL+3);yyyPrune(1);}}
	|	S  Q
	{if(yyyYok){
yyyRSU(2,2,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+3,yyyRCIL+6);yyyPrune(2);}}
 		 
Q	:	WHERE  InList  Where  CONSTRUCT  Cons
	{if(yyyYok){
yyyRSU(3,5,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+6,yyyRCIL+9);yyyPrune(3);}}

	|	WHERE  InList  CONSTRUCT  Cons
	{if(yyyYok){
yyyRSU(4,4,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+9,yyyRCIL+12);yyyPrune(4);}}

InList	:	In
        {if(yyyYok){
yyyRSU(5,1,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+12,yyyRCIL+15);yyyPrune(5);}}
	|	In  InList
	{if(yyyYok){
yyyRSU(6,2,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+15,yyyRCIL+18);yyyPrune(6);}}

In	:	Tp  INN  STRING
	{if(yyyYok){
yyyRSU(7,3,1,4);
yyyGenIntNode();
	(((yyyP2)(((char *)((yyySTN->cL)[0]))+yyyGNSz))->path) = TpPathTagExp(); 
	yyyAdjustINRC(yyyRCIL+18,yyyRCIL+24);yyyPrune(7);}}
	/*	In : Tp  IN  "(filename)"  */

	|	Tp  INN  VAR
	{if(yyyYok){
yyyRSU(8,3,1,4);
yyyGenIntNode();
	(((yyyP2)(((char *)((yyySTN->cL)[0]))+yyyGNSz))->path) = TpPathTagExp();
	yyyAdjustINRC(yyyRCIL+24,yyyRCIL+30);yyyPrune(8);}}
	/*	In : Tp  IN  $ID	   */

Tp	:	LT  ID  GT  LTSLASH  GT
	{if(yyyYok){
yyyRSU(9,5,4,2);
yyyGenIntNode();
	(((yyyP2)yyySTsn)->env) = TpTEnvTagExp();; 	
		(((yyyP2)yyySTsn)->tag) = TpTag((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
			(((yyyP2)yyySTsn)->trans) = TpTransTagExp((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
		yyyAdjustINRC(yyyRCIL+30,yyyRCIL+39);yyyPrune(9);}}
	/*	<ID></>	 */

	|	LT  ID  GT  LTSLASH  ID  GT
        {if(yyyYok){
yyyRSU(10,6,4,2);
yyyGenIntNode();
      (((yyyP2)yyySTsn)->env) = TpTEnvTagExp();
        	(((yyyP2)yyySTsn)->tag) = TpTag((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str)); 
	 	      (((yyyP2)yyySTsn)->trans) = TpTransTagExp((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
                yyyAdjustINRC(yyyRCIL+39,yyyRCIL+48);yyyPrune(10);}}
        /*      <ID></ID>  */


	|	LT  ID  GT  VAR  LTSLASH  GT
	{if(yyyYok){
yyyRSU(11,6,4,2);
yyyGenIntNode();
      (((yyyP2)yyySTsn)->tag) = TpTag((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
		 	(((yyyP2)yyySTsn)->trans) = TpTransTagExp((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
		yyyAdjustINRC(yyyRCIL+48,yyyRCIL+57);}}
	/* 	<ID> VAR </>	*/

	|	LT  ID  GT  VAR  LTSLASH  ID  GT
      	{if(yyyYok){
yyyRSU(12,7,4,2);
yyyGenIntNode();
      (((yyyP2)yyySTsn)->tag) = TpTag((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
		      (((yyyP2)yyySTsn)->trans) = TpTransTagExp((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
                yyyAdjustINRC(yyyRCIL+57,yyyRCIL+66);}}
	/*	<ID> VAR </ID>	*/
	
	|	LT  ID  GT  STRING  LTSLASH  GT
	{if(yyyYok){
yyyRSU(13,6,4,2);
yyyGenIntNode();
	(((yyyP2)yyySTsn)->env) = TpFEnvTagExp();
		(((yyyP2)yyySTsn)->tag) = TpTag((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
			(((yyyP2)yyySTsn)->trans) = TpTransTagExp((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str), (((yyyP1)(((char *)((yyySTN->cL)[3]))+yyyGNSz))->str));
		yyyAdjustINRC(yyyRCIL+66,yyyRCIL+75);yyyPrune(13);}}
	/*	<ID> STRING </>	*/

	|	LT  ID  GT  STRING  LTSLASH  ID  GT
	{if(yyyYok){
yyyRSU(14,7,4,2);
yyyGenIntNode();
      (((yyyP2)yyySTsn)->env) = TpFEnvTagExp();
        	(((yyyP2)yyySTsn)->tag) = TpTag((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
		      (((yyyP2)yyySTsn)->trans) = TpTransTagExp((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str), (((yyyP1)(((char *)((yyySTN->cL)[3]))+yyyGNSz))->str));
                yyyAdjustINRC(yyyRCIL+75,yyyRCIL+84);yyyPrune(14);}}
	/*	<ID> STRING </ID> 	*/
	
	|	Tp  ELEMENTAS  VAR
	{if(yyyYok){
yyyRSU(15,3,4,2);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+84,yyyRCIL+96);}}
	/*	Tp  ELEMENT_AS  VAR	0 --- ELEMENT_AS */

	|	Tp  CONTENTAS  VAR
	{if(yyyYok){
yyyRSU(16,3,4,2);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+96,yyyRCIL+108);}}
	/*	Tp  CONTENT_AS  VAR	1 --- CONTENT_AS */
	
	|	LT  ID  GT  TpList  LTSLASH  GT
	{if(yyyYok){
yyyRSU(17,6,4,2);
yyyGenIntNode();
	(((yyyP2)yyySTsn)->tag) = TpTag((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
		yyyAdjustINRC(yyyRCIL+108,yyyRCIL+120);}}
	/*	<ID> Tp1 Tp2 ... Tpn </>	*/
	
	|       LT  ID  GT  TpList  LTSLASH  ID  GT
        {if(yyyYok){
yyyRSU(18,7,4,2);
yyyGenIntNode();
	(((yyyP2)yyySTsn)->tag) = TpTag((((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str));
                yyyAdjustINRC(yyyRCIL+120,yyyRCIL+132);}}
	/*	<ID> Tp1 Tp2 ... Tpn </ID>	*/

TpList	:	Tp  
	{if(yyyYok){
yyyRSU(19,1,3,3);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+132,yyyRCIL+141);}} 

	|	 Tp  TpList
	{if(yyyYok){
yyyRSU(20,2,3,3);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+141,yyyRCIL+153);}}


Cons	:	Elem	
	{if(yyyYok){
yyyRSU(21,1,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+153,yyyRCIL+156);yyyPrune(21);}}
	
Elem	:	VAR	
	{if(yyyYok){
yyyRSU(22,1,1,4);
yyyGenIntNode();
	(((yyyP4)yyySTsn)->trans) = ElemTransFunc( (((yyyP1)(((char *)((yyySTN->cL)[0]))+yyyGNSz))->str) );	
	yyyAdjustINRC(yyyRCIL+156,yyyRCIL+159);yyyPrune(22);}}

	|	LT  ID  GT  ID  LTSLASH  GT
	{if(yyyYok){
yyyRSU(23,6,1,4);
yyyGenIntNode();
	(((yyyP4)yyySTsn)->trans) = ElemTransFunc( 1, (((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str), (((yyyP1)(((char *)((yyySTN->cL)[3]))+yyyGNSz))->str) );	
	yyyAdjustINRC(yyyRCIL+159,yyyRCIL+162);yyyPrune(23);}}
	/*	<ID> ID1 </> 	*/

        |       LT  ID  GT  ID  LTSLASH  ID  GT
        {if(yyyYok){
yyyRSU(24,7,1,4);
yyyGenIntNode();
      (((yyyP4)yyySTsn)->trans) = ElemTransFunc( 1, (((yyyP1)(((char *)((yyySTN->cL)[1]))+yyyGNSz))->str), (((yyyP1)(((char *)((yyySTN->cL)[3]))+yyyGNSz))->str) );
        yyyAdjustINRC(yyyRCIL+162,yyyRCIL+165);yyyPrune(24);}}
        /*      <ID> ID1 </ID>    */      

	|	LT  ID  GT  ElemList LTSLASH  GT
	{if(yyyYok){
yyyRSU(25,6,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+165,yyyRCIL+168);yyyPrune(25);}}	
	/*	<ID> Elem1 Elem2 ... Elemn </>	*/
	
	|	LT  ID  GT  ElemList LTSLASH  ID  GT
        {if(yyyYok){
yyyRSU(26,7,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+168,yyyRCIL+171);yyyPrune(26);}}     
	/*	<ID> Elem1 Elem2 ... Elemn  </ID>  */
             
	|	LBRACE  Q  RBRACE
	{if(yyyYok){
yyyRSU(27,3,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+171,yyyRCIL+174);yyyPrune(27);}}
	/*	{ Q }   */ 

ElemList:	Elem  
	{if(yyyYok){
yyyRSU(28,1,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+174,yyyRCIL+177);yyyPrune(28);}}
	|	Elem  ElemList
	{if(yyyYok){
yyyRSU(29,2,1,4);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+177,yyyRCIL+180);yyyPrune(29);}}

Where	:	Cond
	{if(yyyYok){
yyyRSU(30,1,1,5);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+180,yyyRCIL+183);yyyPrune(30);}}
	|	Cond  COMMA  Where  	
	{if(yyyYok){
yyyRSU(31,3,1,5);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+183,yyyRCIL+186);yyyPrune(31);}}	

Cond	:	Exp  EQ  Exp
	{if(yyyYok){
yyyRSU(32,3,1,5);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+186,yyyRCIL+189);yyyPrune(32);}}
	|	Exp NEQ  Exp
	{if(yyyYok){
yyyRSU(33,3,1,5);
yyyGenIntNode();
yyyAdjustINRC(yyyRCIL+189,yyyRCIL+192);yyyPrune(33);}}

Exp	:	VAR
	{if(yyyYok){
yyyRSU(34,1,1,4);
yyyGenIntNode();
	(((yyyP4)yyySTsn)->trans) = ExpTransFunc("VAR", (((yyyP1)(((char *)((yyySTN->cL)[0]))+yyyGNSz))->str));
	yyyAdjustINRC(yyyRCIL+192,yyyRCIL+195);yyyPrune(34);}}

	|	STRING	
	{if(yyyYok){
yyyRSU(35,1,1,4);
yyyGenIntNode();
	(((yyyP4)yyySTsn)->trans) = ExpTransFunc("STRING", (((yyyP1)(((char *)((yyySTN->cL)[0]))+yyyGNSz))->str));
	yyyAdjustINRC(yyyRCIL+195,yyyRCIL+198);yyyPrune(35);}}
 

%%

int QLerror(char *s){
  cerr<< s << "found at line: "<< lineno3 <<" ("<<QLtext <<")"<<"\n\n";
  return 0;
}






                                                      /*custom*/  
long yyyMaxNbytesNodeStg = 2000000; 
long yyyMaxNrefCounts =    500000; 
long yyyMaxNchildren =     60000; 
long yyyMaxStackSize =     2000; 
long yyySSALspaceSize =    20000; 
long yyyRSmaxSize =        1000; 
long yyyTravStackMaxSize = 2000; 


struct yyyTB yyyTermBuffer; 

char *yyyNodeAndStackSpace; 

char *yyyNodeSpace;
char *yyyNextNodeSpace; 
char *yyyAfterNodeSpace; 


 
struct yyyGenNode **yyyChildListSpace;  
struct yyyGenNode **yyyNextCLspace; 
struct yyyGenNode **yyyAfterChildListSpace; 



yyyRCT *yyyRefCountListSpace;
yyyRCT *yyyNextRCLspace;  
yyyRCT *yyyAfterRefCountListSpace;   



struct yyySolvedSAlistCell {yyyWAT attrbNum; 
                            long next; 
                           }; 
#define yyyLambdaSSAL 0 
long yyySSALCfreeList = yyyLambdaSSAL; 
long yyyNewSSALC = 1; 
 
struct yyySolvedSAlistCell *yyySSALspace; 


 
struct yyyStackItem {struct yyyGenNode *node; 
                     long solvedSAlist; 
                     struct yyyGenNode *oldestNode; 
                    };  

long yyyNbytesStackStg; 
struct yyyStackItem *yyyStack; 
struct yyyStackItem *yyyAfterStack; 
struct yyyStackItem *yyyStackTop; 



struct yyyRSitem {yyyGNT *node; 
                  yyyWST whichSym; 
                  yyyWAT wa;  
                 };  

struct yyyRSitem *yyyRS;  
struct yyyRSitem *yyyRSTop;  
struct yyyRSitem *yyyAfterRS;  
 





yyyFT yyyRCIL[] = {
yyyR,0,1, yyyR,0,1, yyyR,0,3, yyyR,0,2, yyyR,0,1, yyyR,0,2, 
yyyR,0,2, 0,1,0, yyyR,0,2, 0,1,0, yyyR,0,0, yyyR,2,0, 
yyyR,3,0, yyyR,0,0, yyyR,2,0, yyyR,3,0, yyyR,0,0, yyyR,2,0, 
yyyR,3,1, yyyR,0,0, yyyR,2,0, yyyR,3,1, yyyR,0,0, yyyR,2,0, 
yyyR,3,0, yyyR,0,0, yyyR,2,0, yyyR,3,0, yyyR,0,1, yyyR,2,1, 
yyyR,3,3, 0,1,1, yyyR,0,1, yyyR,2,1, yyyR,3,3, 0,1,1, 
yyyR,0,0, yyyR,2,1, yyyR,3,1, 3,0,1, yyyR,0,0, yyyR,2,1, 
yyyR,3,1, 3,0,1, yyyR,1,1, yyyR,2,1, 0,1,1, yyyR,1,2, 
yyyR,2,2, 0,1,1, 1,0,1, yyyR,0,1, yyyR,0,0, yyyR,0,0, 
yyyR,0,0, yyyR,0,1, yyyR,0,1, yyyR,0,1, yyyR,0,1, yyyR,0,2, 
yyyR,0,1, yyyR,0,2, yyyR,0,2, yyyR,0,2, yyyR,0,0, yyyR,0,0, 

};

short yyyIIIEL[] = {0,
0,2,5,11,16,18,21,25,29,35,
42,49,57,64,72,76,80,87,95,97,
100,102,104,111,119,126,134,138,140,143,
145,149,153,157,159,
};

long yyyIIEL[] = {
0,1,2,3,4,5,6,6,7,8,8,9,
10,10,11,11,12,13,14,15,16,17,18,22,
22,23,24,28,28,29,33,33,34,34,34,34,
38,38,39,39,39,40,40,44,44,45,45,46,
46,46,50,50,51,51,52,52,53,53,57,57,
58,58,59,59,59,63,63,64,64,65,65,66,
66,70,74,74,75,79,83,83,84,88,88,89,
89,92,92,92,96,96,97,97,100,100,101,101,
104,108,111,115,118,119,120,121,122,123,123,124,
124,125,125,125,126,126,127,127,128,128,129,129,
130,130,131,131,132,132,132,133,133,134,134,135,
135,136,136,137,137,138,138,139,140,141,142,143,
144,145,146,147,147,148,149,150,150,151,152,153,
153,154,155,156,157,
};

long yyyIEL[] = {
0,0,2,2,2,4,4,6,
8,10,10,12,14,14,16,16,
18,20,20,20,20,22,24,26,
26,26,26,28,30,32,32,32,
32,32,36,36,36,36,36,40,
40,40,42,42,42,48,50,50,
52,52,52,58,60,60,60,60,
60,60,64,66,66,66,66,66,
70,72,72,72,76,76,76,80,
80,82,84,86,86,90,90,90,
94,94,96,98,100,100,102,102,
102,108,108,110,112,112,114,114,
114,120,120,122,124,124,126,126,
126,126,126,128,130,132,132,132,
132,134,136,138,138,140,142,142,
144,144,146,146,148,150,150,152,
154,154,154,156,158,158,160,162,
162,162,164,164,166,166,168,170,
170,172,172,174,176,176,178,180,
180,182,184,184,186,186,188,
};

yyyFT yyyEntL[] = {
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,2,0,0,0,2,0,3,0,0,0,2,0,3,
0,3,0,3,0,0,0,2,0,3,0,3,0,0,0,2,
0,2,0,0,0,2,0,2,0,3,1,1,0,0,0,3,
0,2,0,3,0,3,0,3,1,1,0,0,0,3,0,2,
0,3,0,3,4,0,0,0,0,2,4,0,0,2,0,3,
4,0,0,0,0,2,4,0,0,2,0,3,1,1,0,1,
0,2,1,1,2,0,0,1,0,2,0,1,0,2,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,
};

#define yyyPermitUserAlloc  0 


void yyyfatal(char *msg)
{fprintf(stderr,msg);exit(-1);} 



#define yyyNSof   'n' 
#define yyyRCof   'r' 
#define yyyCLof   'c' 
#define yyySof    's' 
#define yyySSALof 'S' 
#define yyyRSof   'q' 
#define yyyTSof   't' 



void yyyHandleOverflow(char which) 
  {char *msg1,*msg2; 
   long  oldSize,newSize; 
   switch(which) 
     {
      case yyyNSof   : 
           msg1 = "node storage overflow: ";
           oldSize = yyyMaxNbytesNodeStg; 
           break; 
      case yyyRCof   : 
           msg1 = "dependee count overflow: ";
           oldSize = yyyMaxNrefCounts; 
           break; 
      case yyyCLof   : 
           msg1 = "child list overflow: ";
           oldSize = yyyMaxNchildren; 
           break; 
      case yyySof    : 
           msg1 = "parse-tree stack overflow: ";
           oldSize = yyyMaxStackSize; 
           break; 
      case yyySSALof : 
           msg1 = "SSAL overflow: ";
           oldSize = yyySSALspaceSize; 
           break; 
      case yyyRSof   : 
           msg1 = "ready set overflow: ";
           oldSize = yyyRSmaxSize; 
           break; 
      case yyyTSof   : 
           msg1 = "traversal stack overflow: ";
           oldSize = yyyTravStackMaxSize; 
           break; 
      default        :;  
     }
   newSize = (3*oldSize)/2; 
   if (newSize < 100) newSize = 100; 
   fprintf(stderr,msg1); 
   fprintf(stderr,"size was %d.\n",oldSize); 
   if (yyyPermitUserAlloc) 
      msg2 = "     Try -Y%c%d option.\n"; 
      else 
      msg2 = "     Have to modify evaluator:  -Y%c%d.\n"; 
   fprintf(stderr,msg2,which,newSize); 
   exit(-1); 
  }



void yyySignalEnts(register yyyGNT *node,
                   register yyyFT *startP,register yyyFT *stopP) 
  {register yyyGNT *dumNode; 

   while (startP < stopP)  
     {
      if (!(*startP)) dumNode = node;  
         else dumNode = (node->cL)[(*startP)-1];   
      if (!(--((dumNode->refCountList)[*(startP+1)]
              ) 
           )
         ) 
         { 
          if (++yyyRSTop == yyyAfterRS) 
             {yyyHandleOverflow(yyyRSof); 
              break; 
             }
          yyyRSTop->node = dumNode; 
          yyyRSTop->whichSym = *startP;  
          yyyRSTop->wa = *(startP+1);  
         }  
      startP += 2;  
     }  
  } 




#define yyyCeiling(num,inc) (((inc) * ((num)/(inc))) + (((num)%(inc))?(inc):0)) 



int yyyAlignSize = 4;
int yyyNdSz[6];

int yyyNdPrSz[6];

typedef int yyyCopyType;

int yyyNdCopySz[6];
long yyyBiggestNodeSize = 0;

void yyyNodeSizeCalc()
  {int i;
   yyyGNSz = yyyCeiling(yyyGNSz,yyyAlignSize); 
   yyyNdSz[0] = 0;
   yyyNdSz[1] = sizeof(struct yyyT1);
   yyyNdSz[2] = sizeof(struct yyyT2);
   yyyNdSz[3] = sizeof(struct yyyT3);
   yyyNdSz[4] = sizeof(struct yyyT4);
   yyyNdSz[5] = sizeof(struct yyyT5);
   for (i=0;i<6;i++) 
       {yyyNdSz[i] = yyyCeiling(yyyNdSz[i],yyyAlignSize); 
        yyyNdPrSz[i] = yyyNdSz[i] + yyyGNSz;
        if (yyyBiggestNodeSize < yyyNdSz[i])
           yyyBiggestNodeSize = yyyNdSz[i];
        yyyNdCopySz[i] = yyyCeiling(yyyNdSz[i],sizeof(yyyCopyType)) / 
                         sizeof(yyyCopyType); 
       }
  }




void yyySolveAndSignal() {
register long yyyiDum,*yyypL;
register int yyyws,yyywa;
register yyyGNT *yyyRSTopN,*yyyRefN; 
register void *yyyRSTopNp; 


yyyRSTopNp = (yyyRSTopN = yyyRSTop->node)->parent;
yyyRefN= (yyyws = (yyyRSTop->whichSym))?((yyyGNT *)yyyRSTopNp):yyyRSTopN;
yyywa = yyyRSTop->wa; 
yyyRSTop--;
switch(yyyRefN->prodNum) {
case 1:  /***yacc rule 1***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
  result = (((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = (((yyyP4)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans);
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 2:  /***yacc rule 2***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
  result = (((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = (((yyyP4)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->trans);
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 3:  /***yacc rule 3***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
  (((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = QFunc ((((yyyP4)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->trans), (((yyyP5)(((char *)((yyyRefN->cL)[2]))+yyyGNSz))->trans), (((yyyP4)(((char *)((yyyRefN->cL)[4]))+yyyGNSz))->trans));
	    break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 3:  /**/
    switch (yyywa) {
    }
  break;
  case 5:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 4:  /***yacc rule 4***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
   (((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = QFunc((((yyyP4)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->trans), (((yyyP4)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->trans) );	
	    break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 5:  /***yacc rule 5***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
  (((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = InListTransFunc( (((yyyP4)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans) ); 
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 6:  /***yacc rule 6***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
  (((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = InListTransFunc( (((yyyP4)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans), (((yyyP4)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->trans));
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 7:  /***yacc rule 7***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = InTransFunc("STRING", (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->env), (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans), (((yyyP1)(((char *)((yyyRefN->cL)[2]))+yyyGNSz))->str)); 
		    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  case 3:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 8:  /***yacc rule 8***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = InTransFunc("VAR", (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->env), (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans), (((yyyP1)(((char *)((yyyRefN->cL)[2]))+yyyGNSz))->str));
		    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  case 3:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 9:  /***yacc rule 9***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 10:  /***yacc rule 10***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 5:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 11:  /***yacc rule 11***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 3:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->env) = TpEnvTagExp((((yyyP2)(((char *)yyyRefN)+yyyGNSz))->path), (((yyyP1)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->str), (((yyyP1)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->str));
	    break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 12:  /***yacc rule 12***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 3:
      (((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->env) = TpEnvTagExp((((yyyP2)(((char *)yyyRefN)+yyyGNSz))->path), (((yyyP1)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->str), (((yyyP1)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->str));
            break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  case 6:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 13:  /***yacc rule 13***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 14:  /***yacc rule 14***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  case 6:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 15:  /***yacc rule 15***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->tag) = CopyTag ((((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->tag));
		    break;
    case 2:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->trans) = TpTransTagExp((((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans));
		    break;
    case 3:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->env) =  TpEnvTagExp (0,  (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->env), (((yyyP2)(((char *)yyyRefN)+yyyGNSz))->path), (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->tag), (((yyyP1)(((char *)((yyyRefN->cL)[2]))+yyyGNSz))->str)); 
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    case 1:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->path) = CopyTagExp ((((yyyP2)(((char *)yyyRefN)+yyyGNSz))->path));
		    break;
    }
  break;
  case 3:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 16:  /***yacc rule 16***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->tag) = CopyTag ((((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->tag));
		    break;
    case 2:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->trans) = TpTransTagExp ( (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans) );
		    break;
    case 3:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->env) = TpEnvTagExp (1,  (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->env), (((yyyP2)(((char *)yyyRefN)+yyyGNSz))->path), (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->tag), (((yyyP1)(((char *)((yyyRefN->cL)[2]))+yyyGNSz))->str)); 
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    case 1:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->path) = CopyTagExp ((((yyyP2)(((char *)yyyRefN)+yyyGNSz))->path));
		    break;
    }
  break;
  case 3:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 17:  /***yacc rule 17***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 2:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->trans) =TpTransTagExp ( (((yyyP1)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->str),  (((yyyP3)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->trans) );
	    break;
    case 3:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->env) = CopyTagExp ((((yyyP3)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->env));
		    break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP3)(((char *)yyyRSTopN)+yyyGNSz))->path) = TpListPathTagExp((((yyyP1)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->str), (((yyyP2)(((char *)yyyRefN)+yyyGNSz))->path));
		    break;
    }
  break;
  }
break;
case 18:  /***yacc rule 18***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 2:
      (((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->trans) =TpTransTagExp( (((yyyP1)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->str),  (((yyyP3)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->trans) );
            break;
    case 3:
      (((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->env) = CopyTagExp ((((yyyP3)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->env));
                    break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    case 0:
      (((yyyP3)(((char *)yyyRSTopN)+yyyGNSz))->path) = TpListPathTagExp((((yyyP1)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->str), (((yyyP2)(((char *)yyyRefN)+yyyGNSz))->path));
		    break;
    }
  break;
  case 6:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 19:  /***yacc rule 19***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 1:
	(((yyyP3)(((char *)yyyRSTopN)+yyyGNSz))->trans) = TpListTransTagExpList((((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans));; 
		    break;
    case 2:
	(((yyyP3)(((char *)yyyRSTopN)+yyyGNSz))->env) = CopyTagExp ((((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->env)); 
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    case 1:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->path) =CopyTagExp ((((yyyP3)(((char *)yyyRefN)+yyyGNSz))->path));
		    break;
    }
  break;
  }
break;
case 20:  /***yacc rule 20***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 1:
	(((yyyP3)(((char *)yyyRSTopN)+yyyGNSz))->trans) = TpListTransTagExpList ((((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans), (((yyyP3)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->trans)); 
		    break;
    case 2:
	(((yyyP3)(((char *)yyyRSTopN)+yyyGNSz))->env) = TpListEnvTagExp ( (((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->env), (((yyyP3)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->env) );
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    case 1:
	(((yyyP2)(((char *)yyyRSTopN)+yyyGNSz))->path) = CopyTagExp ((((yyyP3)(((char *)yyyRefN)+yyyGNSz))->path));
		    yyySignalEnts(yyyRefN,yyyEntL+132,yyyEntL+134);
    break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP3)(((char *)yyyRSTopN)+yyyGNSz))->path) = CopyTagExp ((((yyyP2)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->path));
		    break;
    }
  break;
  }
break;
case 21:  /***yacc rule 21***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = ConsTransFunc( (((yyyP4)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans) );
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 22:  /***yacc rule 22***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 23:  /***yacc rule 23***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 24:  /***yacc rule 24***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  case 6:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 25:  /***yacc rule 25***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = ElemTransFunc((((yyyP1)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->str), (((yyyP4)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->trans));
	    break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 26:  /***yacc rule 26***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
      (((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = ElemTransFunc((((yyyP1)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->str), (((yyyP4)(((char *)((yyyRefN->cL)[3]))+yyyGNSz))->trans));
            break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  case 4:  /**/
    switch (yyywa) {
    }
  break;
  case 6:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 27:  /***yacc rule 27***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = CopyFunc ( (((yyyP4)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->trans) );
	    break;
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 28:  /***yacc rule 28***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = CopyFunc ( (((yyyP4)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans) );
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 29:  /***yacc rule 29***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP4)(((char *)yyyRSTopN)+yyyGNSz))->trans) = ElemListTransFunc( (((yyyP4)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans), (((yyyP4)(((char *)((yyyRefN->cL)[1]))+yyyGNSz))->trans) );
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  case 2:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 30:  /***yacc rule 30***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP5)(((char *)yyyRSTopN)+yyyGNSz))->trans) =  CopyPred ( (((yyyP5)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans) );	
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 31:  /***yacc rule 31***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP5)(((char *)yyyRSTopN)+yyyGNSz))->trans) = WhereTransPred ( (((yyyP5)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans), (((yyyP5)(((char *)((yyyRefN->cL)[2]))+yyyGNSz))->trans) );	
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  case 3:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 32:  /***yacc rule 32***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP5)(((char *)yyyRSTopN)+yyyGNSz))->trans) = CondTransPred("EQ", (((yyyP4)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans), (((yyyP4)(((char *)((yyyRefN->cL)[2]))+yyyGNSz))->trans));
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  case 3:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 33:  /***yacc rule 33***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    case 0:
	(((yyyP5)(((char *)yyyRSTopN)+yyyGNSz))->trans) = CondTransPred("NEQ", (((yyyP4)(((char *)((yyyRefN->cL)[0]))+yyyGNSz))->trans), (((yyyP4)(((char *)((yyyRefN->cL)[2]))+yyyGNSz))->trans));
	    break;
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  case 3:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 34:  /***yacc rule 34***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
case 35:  /***yacc rule 35***/
  switch (yyyws) {
  case 0:  /**/
    switch (yyywa) {
    }
  break;
  case 1:  /**/
    switch (yyywa) {
    }
  break;
  }
break;
} /* switch */ 

if (yyyws)  /* the just-solved instance was inherited. */ 
   {if (yyyRSTopN->prodNum) 
       {yyyiDum = yyyIIEL[yyyIIIEL[yyyRSTopN->prodNum]] + yyywa;
        yyySignalEnts(yyyRSTopN,yyyEntL + yyyIEL[yyyiDum],
                                yyyEntL + yyyIEL[yyyiDum+1]
                     );
       }
   } 
   else     /* the just-solved instance was synthesized. */ 
   {if ((char *)yyyRSTopNp >= yyyNodeSpace) /* node has a parent. */ 
       {yyyiDum = yyyIIEL[yyyIIIEL[((yyyGNT *)yyyRSTopNp)->prodNum] + 
                          yyyRSTopN->whichSym 
                         ] + 
                  yyywa;
        yyySignalEnts((yyyGNT *)yyyRSTopNp,
                      yyyEntL + yyyIEL[yyyiDum],
                      yyyEntL + yyyIEL[yyyiDum+1] 
                     );
       } 
       else   /* node is still on the stack--it has no parent yet. */ 
       {yyypL = &(((struct yyyStackItem *)yyyRSTopNp)->solvedSAlist); 
        if (yyySSALCfreeList == yyyLambdaSSAL) 
           {yyySSALspace[yyyNewSSALC].next = *yyypL; 
            if ((*yyypL = yyyNewSSALC++) == yyySSALspaceSize) 
               yyyHandleOverflow(yyySSALof); 
           }  
           else
           {yyyiDum = yyySSALCfreeList; 
            yyySSALCfreeList = yyySSALspace[yyySSALCfreeList].next; 
            yyySSALspace[yyyiDum].next = *yyypL; 
            *yyypL = yyyiDum;  
           } 
        yyySSALspace[*yyypL].attrbNum = yyywa; 
       } 
   }

} /* yyySolveAndSignal */ 



void yyyDoTraversals(){}
void yyyExecuteRRsection()  {
   int yyyi; 
   long yyynRefCounts; 
   long cycleSum = 0;
   long nNZrc = 0;

   if (!yyyYok) return; 
   yyynRefCounts = yyyNextRCLspace - yyyRefCountListSpace; 
   for (yyyi=0;yyyi<yyynRefCounts;yyyi++) 
     if (yyyRefCountListSpace[yyyi])
        {cycleSum += yyyRefCountListSpace[yyyi]; nNZrc++;} 
   if (nNZrc) 
      {
       fprintf(stderr,"\n\n\n**********\n");
       fprintf(stderr,
               "cycle detected in completed parse tree");
       fprintf(stderr,
               " after decoration.\n");
       fprintf(stderr,
         "searching parse tree for %d unsolved instances:\n",
               nNZrc
              );
       yyyUnsolvedInstSearchTravAux(yyyStackTop->node);
      }
   yyyDoTraversals();
} /* yyyExecuteRRsection */ 



yyyWAT yyyLRCIL[3] = {0,0,0,
};



void yyyYoxInit()                                  /*stock*/  
  { 

   yyyNodeSizeCalc(); 

   if ((yyyTermBuffer.snBufPtr = 
        (char *) malloc((size_t)(yyyBiggestNodeSize + sizeof(yyyCopyType)))
       )  
       == 
       ((char *) NULL) 
      )   
      yyyfatal("malloc error in yyyTermBuffer allocation\n");  
  
  
   yyyNbytesStackStg = yyyMaxStackSize*sizeof(struct yyyStackItem); 
   yyyNbytesStackStg = ((yyyNbytesStackStg/yyyAlignSize)+1)*yyyAlignSize;  
   if ((yyyNodeAndStackSpace = 
        (char *) malloc((size_t)(yyyNbytesStackStg + 
                                 yyyMaxNbytesNodeStg + 
                                 yyyGNSz + 
                                 yyyBiggestNodeSize + 
                                 sizeof(yyyCopyType) 
                                )
                       )
       )  
       == 
       ((char *) NULL) 
      )   
      yyyfatal("malloc error in ox node and stack space allocation\n");
   yyyStack = (struct yyyStackItem *) yyyNodeAndStackSpace; 
   yyyAfterStack = yyyStack + yyyMaxStackSize;  
   yyyNodeSpace = yyyNodeAndStackSpace + yyyNbytesStackStg;
   yyyAfterNodeSpace = yyyNodeSpace + yyyMaxNbytesNodeStg;
 
 
   if ((yyyRS = (struct yyyRSitem *) 
         malloc((size_t)((yyyRSmaxSize+1)*sizeof(struct yyyRSitem)))
       )  
       == 
       ((struct yyyRSitem *) NULL) 
      )   
      yyyfatal("malloc error in ox ready set space allocation\n");  
   yyyRS++; 
   yyyAfterRS = yyyRS + yyyRSmaxSize; 

 
   if ((yyyChildListSpace = 
        (yyyGNT **) malloc((size_t)(yyyMaxNchildren*sizeof(yyyGNT *)))
       )  
       == 
       ((yyyGNT **) NULL) 
      )   
      yyyfatal("malloc error in ox child list space allocation\n");  
   yyyAfterChildListSpace = yyyChildListSpace + yyyMaxNchildren; 

 
   if ((yyyRefCountListSpace = 
        (yyyRCT *) malloc((size_t)(yyyMaxNrefCounts * sizeof(yyyRCT)))
       )  
       == 
       ((yyyRCT *) NULL) 
      )   
      yyyfatal("malloc error in ox reference count list space allocation\n");  
   yyyAfterRefCountListSpace = yyyRefCountListSpace + yyyMaxNrefCounts;  
  
 
   if ((yyySSALspace = (struct yyySolvedSAlistCell *) 
          malloc((size_t)((yyySSALspaceSize+1) * 
                          sizeof(struct yyySolvedSAlistCell))
                         ) 
       ) 
       == 
       ((struct yyySolvedSAlistCell *) NULL) 
      ) 
      yyyfatal("malloc error in stack solved list space allocation\n"); 
  } /* yyyYoxInit */ 



void yyyYoxReset() 
  { 
   yyyTermBuffer.isEmpty = 1; 
   yyyStackTop = yyyStack; 
   while (yyyStackTop != yyyAfterStack) 
     (yyyStackTop++)->solvedSAlist = yyyLambdaSSAL; 
   yyyStackTop = yyyStack - 1; 
   yyyNextNodeSpace = yyyNodeSpace; 
   yyyRSTop = yyyRS - 1; 
   yyyNextCLspace = yyyChildListSpace;
   yyyNextRCLspace = yyyRefCountListSpace; 
  }  



void yyyDecorate() 
  { 
   while (yyyRSTop >= yyyRS) 
      yyySolveAndSignal();  
  } 



void yyyShift() 
  {yyyRCT *rcPdum; 
   register yyyCopyType *CTp1,*CTp2,*CTp3; 
   register yyyWAT *startP,*stopP;  

   if ((++yyyStackTop) == yyyAfterStack) 
      yyyHandleOverflow(yyySof);
   CTp2 = (yyyCopyType *)(yyyStackTop->oldestNode = 
                          yyyStackTop->node = 
                          (yyyGNT *)yyyNextNodeSpace 
                         ); 
   yyyTermBuffer.isEmpty = 1;
   ((yyyGNT *)CTp2)->parent = (void *)yyyStackTop; 
   ((yyyGNT *)CTp2)->cL = yyyNextCLspace;  
   rcPdum = ((yyyGNT *)CTp2)->refCountList = yyyNextRCLspace;  
   ((yyyGNT *)CTp2)->prodNum = 0; 
   if ((yyyNextRCLspace += yyyTermBuffer.nAttrbs) 
       > 
       yyyAfterRefCountListSpace 
      ) 
      yyyHandleOverflow(yyyRCof); 
   startP = yyyTermBuffer.startP;  
   stopP = yyyTermBuffer.stopP;  
   while (startP < stopP) rcPdum[*(startP++)] = 0; 
   if ((yyyNextNodeSpace += yyyNdPrSz[yyyTermBuffer.typeNum]) 
       > 
       yyyAfterNodeSpace 
      ) 
      yyyHandleOverflow(yyyNSof);  
   CTp1 = (yyyCopyType *)(yyyTermBuffer.snBufPtr); 
   CTp2 = (yyyCopyType *)(((char *)CTp2) + yyyGNSz); 
   CTp3 = CTp2 + yyyNdCopySz[yyyTermBuffer.typeNum]; 
   while (CTp2 < CTp3) *CTp2++ = *CTp1++; 
  } 



void yyyGenIntNode() 
  {register yyyWST i;
   register struct yyyStackItem *stDum;  
   register yyyGNT *gnpDum; 

   if ((stDum = (yyyStackTop -= (yyyRHSlength-1))) >= yyyAfterStack) 
      yyyHandleOverflow(yyySof);
   yyySTsn = ((char *)(yyySTN = (yyyGNT *)yyyNextNodeSpace)) + yyyGNSz; 
   yyySTN->parent       =  (void *)yyyStackTop;  
   yyySTN->cL           =  yyyNextCLspace; 
   yyySTN->refCountList =  yyyNextRCLspace; 
   yyySTN->prodNum      =  yyyProdNum; 
   if ((yyyNextCLspace+yyyRHSlength) > yyyAfterChildListSpace) 
      yyyHandleOverflow(yyyCLof); 
   for (i=1;i<=yyyRHSlength;i++) 
     {gnpDum = *(yyyNextCLspace++) = (stDum++)->node;  
      gnpDum->whichSym = i;  
      gnpDum->parent = (void *)yyyNextNodeSpace; 
     } 
   if ((yyyNextRCLspace += yyyNattrbs) > yyyAfterRefCountListSpace) 
      yyyHandleOverflow(yyyRCof); 
   if ((yyyNextNodeSpace += yyyNdPrSz[yyyTypeNum]) > yyyAfterNodeSpace) 
      yyyHandleOverflow(yyyNSof);  
  } 



#define yyyDECORfREQ 50 



void yyyAdjustINRC(register yyyFT *startP, register yyyFT *stopP) 
  {yyyWST i;
   long SSALptr,SSALptrHead,*cPtrPtr; 
   long *pL; 
   struct yyyStackItem *stDum;  
   yyyGNT *gnpDum; 
   long iTemp;
   register yyyFT *nextP;
   static unsigned short intNodeCount = yyyDECORfREQ;

   nextP = startP;
   while (nextP < stopP) 
     {if ((*nextP) == yyyR)  
         {(yyySTN->refCountList)[*(nextP+1)] = *(nextP+2);
         } 
         else 
         {(((yyySTN->cL)[*nextP])->refCountList)[*(nextP+1)] = *(nextP+2);
         } 
      nextP += 3;  
     }
   pL = yyyIIEL + yyyIIIEL[yyyProdNum]; 
   stDum = yyyStackTop;  
   for (i=1;i<=yyyRHSlength;i++) 
     {pL++; 
      SSALptrHead = SSALptr = *(cPtrPtr = &((stDum++)->solvedSAlist)); 
      if (SSALptr != yyyLambdaSSAL) 
         {*cPtrPtr = yyyLambdaSSAL; 
          do 
            {
             iTemp = (*pL+yyySSALspace[SSALptr].attrbNum);
             yyySignalEnts(yyySTN,
                           yyyEntL + yyyIEL[iTemp],
                           yyyEntL + yyyIEL[iTemp+1]
                          );  
             SSALptr = *(cPtrPtr = &(yyySSALspace[SSALptr].next)); 
            } 
            while (SSALptr != yyyLambdaSSAL);  
          *cPtrPtr = yyySSALCfreeList;  
          yyySSALCfreeList = SSALptrHead;  
         } 
     } 
   nextP = startP + 2;
   while (nextP < stopP) 
     {if (!(*nextP))
         {if ((*(nextP-2)) == yyyR)  
             {pL = &(yyyStackTop->solvedSAlist); 
              if (yyySSALCfreeList == yyyLambdaSSAL) 
                 {yyySSALspace[yyyNewSSALC].next = *pL; 
                  if ((*pL = yyyNewSSALC++) == yyySSALspaceSize) 
                     yyyHandleOverflow(yyySSALof); 
                 }  
                 else
                 {iTemp = yyySSALCfreeList; 
                  yyySSALCfreeList = yyySSALspace[yyySSALCfreeList].next; 
                  yyySSALspace[iTemp].next = *pL; 
                  *pL = iTemp;  
                 } 
              yyySSALspace[*pL].attrbNum = *(nextP-1); 
             } 
             else 
             {if ((gnpDum = (yyySTN->cL)[*(nextP-2)])->prodNum != 0)
                 {
                  iTemp = yyyIIEL[yyyIIIEL[gnpDum->prodNum]] + *(nextP-1);
                  yyySignalEnts(gnpDum, 
                                yyyEntL + yyyIEL[iTemp],  
                                yyyEntL + yyyIEL[iTemp+1] 
                               );    
                 }  
             } 
         } 
      nextP += 3; 
     } 
   yyyStackTop->node = yyySTN;
   if (!yyyRHSlength) yyyStackTop->oldestNode = yyySTN; 
   if (!--intNodeCount) 
      {intNodeCount = yyyDECORfREQ; 
       yyyDecorate(); 
      } 
  } 



void yyyPrune(long prodNum) 
  {  
   int i,n; 
   register char *cp1,*cp2;  
   register yyyRCT *rcp1,*rcp2,*rcp3;  
   long cycleSum = 0;
   long nNZrc = 0;
   yyyRCT *tempNextRCLspace;
   
   yyyDecorate();
   tempNextRCLspace = yyyNextRCLspace;
   yyyNextRCLspace = 
     (rcp1 = rcp2 = (yyyStackTop->oldestNode)->refCountList) + yyyNattrbs;
   rcp3 = (yyyStackTop->node)->refCountList; 
   while (rcp2 < rcp3) 
     if (*rcp2++) {cycleSum += *(rcp2 - 1); nNZrc++;} 
   if (nNZrc) 
      {
       fprintf(stderr,"\n\n\n----------\n");
       fprintf(stderr,
         "cycle detected during pruning of a subtree\n");
       fprintf(stderr,
         "  at whose root production %d is applied.\n",prodNum);
       yyyNextRCLspace = tempNextRCLspace; 
       fprintf(stderr,
         "prune aborted: searching subtree for %d unsolved instances:\n",
               nNZrc
              );
       yyyUnsolvedInstSearchTrav(yyyStackTop->node);
       return; 
      }
   for (i=0;i<yyyNattrbs;i++) rcp1[i] = rcp3[i]; 
   yyyNextCLspace = (yyyStackTop->oldestNode)->cL; 
   yyyNextNodeSpace = (char *)(yyyStackTop->oldestNode) + 
                      (n = yyyNdPrSz[yyyTypeNum]);
   cp1 = (char *)yyyStackTop->oldestNode; 
   cp2 = (char *)yyyStackTop->node; 
   for (i=0;i<n;i++) *cp1++ = *cp2++; 
   yyyStackTop->node = yyyStackTop->oldestNode; 
   (yyyStackTop->node)->refCountList = rcp1; 
   (yyyStackTop->node)->cL = yyyNextCLspace; 
  } 



void yyyGenLeaf(int nAttrbs,int typeNum,yyyWAT *startP,yyyWAT *stopP) 
  {
   if  (!(yyyTermBuffer.isEmpty)) yyyShift(); 
   yyyTermBuffer.isEmpty = 0;
   yyyTermBuffer.typeNum = typeNum; 
   yyyTermBuffer.nAttrbs = nAttrbs; 
   yyyTermBuffer.startP = startP; 
   yyyTermBuffer.stopP = stopP; 
   
  } 



void yyyerror()
  {yyyYok = 0; 
  } 



/* read the command line for changes in sizes of 
                  the evaluator's data structures */
void yyyCheckForResizes(int argc,char *argv[]) 
  {int i; 
   long dum; 
 
   if (!yyyPermitUserAlloc) return; 
   for (i=1;i<argc;i++) 
     { 
      if ((argv[i][0] != '-') || (argv[i][1] != 'Y')) continue; 
      if (strlen(argv[i]) < 4) goto yyyErrO1; 
      if (sscanf(argv[i]+3,"%d",&dum) != 1) goto yyyErrO1;
      if (dum < 2) dum = 2;
      switch (argv[i][2]) 
        {case yyyNSof:   yyyMaxNbytesNodeStg = dum; break; 
         case yyyRCof:   yyyMaxNrefCounts    = dum; break; 
         case yyyCLof:   yyyMaxNchildren     = dum; break; 
         case yyySof:    yyyMaxStackSize     = dum; break; 
         case yyySSALof: yyySSALspaceSize    = dum; break; 
         case yyyRSof:   yyyRSmaxSize        = dum; break; 
         case yyyTSof:   yyyTravStackMaxSize = dum; break; 
         default : goto yyyErrO1; 
        }
      continue;  
   yyyErrO1 : fprintf(stderr,"invalid command line option: %s\n",
                             argv[i] 
                     ); 
     } 
  } 
   
   
   


#define yyyLastProdNum 35


#define yyyNsorts 5


int yyyProdsInd[] = {
   0,
   0,   2,   5,  11,  16,  18,  21,  25,  29,  35,
  42,  49,  57,  64,  72,  76,  80,  87,  95,  97,
 100, 102, 104, 111, 119, 126, 134, 138, 140, 143,
 145, 149, 153, 157, 159,
 161,
};


int yyyProds[][2] = {
{  84,   4},{  82,   4},{  84,   4},{  84,   4},{  82,   4},
{  82,   4},{ 290,   0},{ 789,   4},{ 513,   5},{ 996,   0},
{ 627,   4},{  82,   4},{ 290,   0},{ 789,   4},{ 996,   0},
{ 627,   4},{ 789,   4},{ 955,   4},{ 789,   4},{ 955,   4},
{ 789,   4},{ 955,   4},{ 982,   2},{ 768,   0},{ 925,   1},
{ 955,   4},{ 982,   2},{ 768,   0},{ 933,   1},{ 982,   2},
{ 750,   0},{ 619,   1},{ 745,   0},{1081,   0},{ 745,   0},
{ 982,   2},{ 750,   0},{ 619,   1},{ 745,   0},{1081,   0},
{ 619,   1},{ 745,   0},{ 982,   2},{ 750,   0},{ 619,   1},
{ 745,   0},{ 933,   1},{1081,   0},{ 745,   0},{ 982,   2},
{ 750,   0},{ 619,   1},{ 745,   0},{ 933,   1},{1081,   0},
{ 619,   1},{ 745,   0},{ 982,   2},{ 750,   0},{ 619,   1},
{ 745,   0},{ 925,   1},{1081,   0},{ 745,   0},{ 982,   2},
{ 750,   0},{ 619,   1},{ 745,   0},{ 925,   1},{1081,   0},
{ 619,   1},{ 745,   0},{ 982,   2},{ 982,   2},{1117,   0},
{ 933,   1},{ 982,   2},{ 982,   2},{1139,   0},{ 933,   1},
{ 982,   2},{ 750,   0},{ 619,   1},{ 745,   0},{ 816,   3},
{1081,   0},{ 745,   0},{ 982,   2},{ 750,   0},{ 619,   1},
{ 745,   0},{ 816,   3},{1081,   0},{ 619,   1},{ 745,   0},
{ 816,   3},{ 982,   2},{ 816,   3},{ 982,   2},{ 816,   3},
{ 627,   4},{ 537,   4},{ 537,   4},{ 933,   1},{ 537,   4},
{ 750,   0},{ 619,   1},{ 745,   0},{ 619,   1},{1081,   0},
{ 745,   0},{ 537,   4},{ 750,   0},{ 619,   1},{ 745,   0},
{ 619,   1},{1081,   0},{ 619,   1},{ 745,   0},{ 537,   4},
{ 750,   0},{ 619,   1},{ 745,   0},{ 771,   4},{1081,   0},
{ 745,   0},{ 537,   4},{ 750,   0},{ 619,   1},{ 745,   0},
{ 771,   4},{1081,   0},{ 619,   1},{ 745,   0},{ 537,   4},
{1169,   0},{  82,   4},{1175,   0},{ 771,   4},{ 537,   4},
{ 771,   4},{ 537,   4},{ 771,   4},{ 513,   5},{ 898,   5},
{ 513,   5},{ 898,   5},{1203,   0},{ 513,   5},{ 898,   5},
{ 814,   4},{ 719,   0},{ 814,   4},{ 898,   5},{ 814,   4},
{ 893,   0},{ 814,   4},{ 814,   4},{ 933,   1},{ 814,   4},
{ 925,   1},
};


int yyySortsInd[] = {
  0,
  0,  1,  5,  8,  9,
 10,
};


int yyySorts[] = {
  956,  101,  466,  701, 1150,  466,  701, 1150,  701,  701,
};



char *yyyStringTab[] = {
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,"Tag",
0,0,0,0,0,
0,0,0,0,0,
0,0,"Q",0,"S",
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,"tag",0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,"y",0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,"PLUS",
0,0,0,0,0,
"WHERE",0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"Predicate",0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"lexeme",0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,"path",0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"Where",0,
0,0,0,0,0,
0,"QFunc",0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,"Elem","TagExp",0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,"SLASHGT",0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,"CopyTag",0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
"TpTag",0,0,0,"ID",
0,0,0,0,0,
0,0,"Cons",0,0,
0,0,0,0,0,
0,0,"CopyTagExp",0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"TpEnvTagExp","TpPathTagExp",
"TpTransTagExp","TpTEnvTagExp","TpFEnvTagExp","TpListPathTagExp","TpListEnvTagExp",
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
"TagExpList","trans",0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,"EQ",
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
"GT",0,0,0,0,
"LT",0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"INN",0,
0,"ElemList",0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,"InList",
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,"Exp",
0,"TpList",0,0,0,
0,"ElemTransFunc",0,0,0,
"ElemListTransFunc",0,0,0,0,
0,"TpListTransTagExpList",0,0,0,
0,0,0,"CopyFunc","InTransFunc",
0,0,0,"InListTransFunc","ConsTransFunc",
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,"result",0,0,
0,0,0,0,"Function",
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"NEQ",0,
0,0,0,"Cond",0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"BAR",0,
0,"ExpTransFunc",0,0,0,
0,0,0,0,0,
"STRING",0,0,0,0,
0,0,0,"VAR",0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
"In","str",0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,"Tp",0,0,
0,0,0,0,0,
0,0,0,0,0,
0,"CONSTRUCT",0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,"LTSLASH",0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,0,0,
0,0,"ELEMENTAS",0,0,
0,0,0,0,0,
0,"STAR",0,0,0,
0,0,0,0,0,
0,0,0,0,"CONTENTAS",
0,0,0,0,0,
0,0,0,0,0,
"env",0,0,0,0,
"DOT",0,0,0,0,
0,0,0,0,0,
0,0,0,0,"LBRACE",
0,0,0,0,0,
"RBRACE",0,0,0,0,
0,0,0,0,0,
0,0,0,"WhereTransPred",0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"COMMA",0,
0,0,0,0,0,
0,0,0,0,0,
0,0,0,"CopyPred",0,
0,0,0,"CondTransPred",0,
0,0,0,0,0,
0,
};



#define yyySizeofProd(num) (yyyProdsInd[(num)+1] - yyyProdsInd[(num)])

#define yyyGSoccurStr(prodNum,symPos) \
   (yyyStringTab[yyyProds[yyyProdsInd[(prodNum)] + (symPos)][0]])

#define yyySizeofSort(num) (yyySortsInd[(num)+1] - yyySortsInd[(num)])

#define yyySortOf(prodNum,symPos) \
  (yyyProds[yyyProdsInd[(prodNum)] + (symPos)][1]) 

#define yyyAttrbStr(prodNum,symPos,attrbNum)                      \
  (yyyStringTab[yyySorts[yyySortsInd[yyySortOf(prodNum,symPos)] + \
                         (attrbNum)                               \
                        ]                                         \
               ]                                                  \
  )



void yyyShowProd(int i)
  {int j,nSyms;

   nSyms = yyySizeofProd(i);
   for (j=0; j<nSyms; j++)
     {
      fprintf(stderr,"%s",yyyGSoccurStr(i,j));
      if (j == 0) fprintf(stderr," : "); else fprintf(stderr," ");
     }
   fprintf(stderr,";\n");
  }



void yyyShowProds()
  {int i; for (i=1; i<=yyyLastProdNum; i++) yyyShowProd(i);}



void yyyShowSymsAndSorts()
  {int i; 

   for (i=1; i<=yyyLastProdNum; i++) 
     {int j, nSyms;

      fprintf(stderr,
              "\n\n\n---------------------------------- %3.1d\n",i);
      /* yyyShowProd(i); */ 
      nSyms = yyySizeofProd(i); 
      for (j=0; j<nSyms; j++) 
        {int k, sortSize;

         fprintf(stderr,"%s\n",yyyGSoccurStr(i,j));
         sortSize = yyySizeofSort(yyySortOf(i,j));
         for (k=0; k<sortSize; k++) 
            fprintf(stderr,"  %s\n",yyyAttrbStr(i,j,k));
         if (j == 0) fprintf(stderr,"->\n"); 
              else 
              fprintf(stderr,"\n"); 
        }
     }
  }



void yyyCheckNodeInstancesSolved(yyyGNT *np)
  {int mysort,sortSize,i,prodNum,symPos,inTerminalNode;
   int nUnsolvedInsts = 0;

   if (np->prodNum != 0)
     {inTerminalNode = 0;
      prodNum = np->prodNum;
      symPos = 0;
     }
   else
     {inTerminalNode = 1;
      prodNum = ((yyyGNT *)(np->parent))->prodNum;
      symPos = np->whichSym;
     }
   mysort = yyySortOf(prodNum,symPos);
   sortSize = yyySizeofSort(mysort);
   for (i=0; i<sortSize; i++)
     if ((np->refCountList)[i] != 0) nUnsolvedInsts += 1;
   if (nUnsolvedInsts)
     {fprintf(stderr,
      "\nFound node that has %d unsolved attribute instance(s).\n",
              nUnsolvedInsts
             );
      fprintf(stderr,"Node is labeled \"%s\".\n",
             yyyGSoccurStr(prodNum,symPos));
      if (inTerminalNode)
        {fprintf(stderr,
                 "Node is terminal.  Its parent production is:\n  ");
         yyyShowProd(prodNum);
        }
      else
        {fprintf(stderr,"Node is nonterminal.  ");
         if (((char *)(np->parent)) >= yyyNodeSpace)
           {fprintf(stderr,
                    "Node is %dth child in its parent production:\n  ",
                   np->whichSym
                  );
            yyyShowProd(((yyyGNT *)(np->parent))->prodNum);
           }
         fprintf(stderr,
                 "Node is on left hand side of this production:\n  ");
         yyyShowProd(np->prodNum);
        }
      fprintf(stderr,"The following instances are unsolved:\n");
      for (i=0; i<sortSize; i++)
        if ((np->refCountList)[i] != 0)
          fprintf(stderr,"     %-16s still has %1d dependencies.\n",
                  yyyAttrbStr(prodNum,symPos,i),(np->refCountList)[i]);
     }
  }



void yyyUnsolvedInstSearchTravAux(yyyGNT *pNode)
  {yyyGNT **yyyCLpdum;
   int i;
  
   yyyCheckNodeInstancesSolved(pNode); 
   yyyCLpdum = pNode->cL;
   while
     ((yyyCLpdum != yyyNextCLspace) && ((*yyyCLpdum)->parent == pNode))
     {
      yyyUnsolvedInstSearchTravAux(*yyyCLpdum);
      yyyCLpdum++;
     }
  }



void yyyUnsolvedInstSearchTrav(yyyGNT *pNode)
  {yyyGNT **yyyCLpdum;
   int i;
  
   yyyCLpdum = pNode->cL;
   while
     ((yyyCLpdum != yyyNextCLspace) && ((*yyyCLpdum)->parent == pNode))
     {
      yyyUnsolvedInstSearchTravAux(*yyyCLpdum);
      yyyCLpdum++;
     }
  }



